# -*- coding: utf-8 -*-
import urllib2
from BeautifulSoup import BeautifulSoup
import re
import MySQLdb as mdb

def __if_number_get_string(number):
    converted_str = number
    if isinstance(number, int) or \
       isinstance(number, float):
        converted_str = str(number)
    return converted_str
 
def get_unicode(strOrUnicode, encoding='utf-8'):
    strOrUnicode = __if_number_get_string(strOrUnicode)
    if isinstance(strOrUnicode, unicode):
        return strOrUnicode
    return unicode(strOrUnicode, encoding, errors='ignore')
 
def get_string(strOrUnicode, encoding='utf-8'):
    strOrUnicode = __if_number_get_string(strOrUnicode)
    if isinstance(strOrUnicode, unicode):
        return strOrUnicode.encode(encoding)
    return strOrUnicode

#crawling throght the whole website
def crawling(url,cur,con,dic,urlList):
	print get_unicode(url)
	try:
		f = urllib2.urlopen(url)
		s = f.read()
		match = re.search(r'http://book.douban.com/subject/[0-9]+/',url)
		#if match the url and not stored yet
		if match and dic.has_key(url) == False:
			#insert into the database
			sql = "insert into book(url) value(%s)"
			cur.execute(sql,[url])
			con.commit()
			# record the url that has been stored
			dic[url] = 1
		soup = BeautifulSoup(s)
		# find all <a></a> tags
		atag = soup.findAll("a")
		for a in atag:
			# extract href contents
			if a.has_key("href") == True:
				href = a["href"]
				match2 = re.search(r'http://\w+.\w+',href)
				# if the link is a normal link, add to urlList
				if match2:
					urlList.append(href)
		while len(urlList) != 0:
			# everytime get the first element of the urlList and continue crawling
			url = urlList.pop(0)
			crawling(url,cur,con,dic,urlList)
		f.close()
	except IOError:
		print 'problem reading url'

def getAPIInfor():
	con = mdb.connect('localhost','root','','douban')
	cur = con.cursor()
	# get all the link we crawled in the first step
	sql = "select url,id from book"
	cur.execute(sql)
	result = cur.fetchall()
	for r in result:
		url = r[0]
		id = r[1]
		book_id = extractBookId(url)
		new_url = "https://api.douban.com/v2/book/"+book_id
		crawlBookAPI(new_url,cur,con,id)

# crawling the json information
def crawlBookAPI(url,cur,con,id):
	try:
		f = urllib2.urlopen(url)
		s = f.read()
		sql = "update book set book_detail = %s where id = %s"
		cur.execute(sql,[s,id])
		con.commit()
		f.close()
	except IOError:
		print 'problem reading url'

def extractBookId(url):
	nPos = url.index('subject/')
	substring = url[nPos+8:]
	nPos = substring.index('/')
	return substring[:nPos]
		
if __name__ == '__main__':
	con = mdb.connect('localhost','root','','douban')
	cur = con.cursor()
	dic = {}
	urlList = []
	crawling("http://book.douban.com/",cur,con,dic,urlList)
#   if you have completed the crawling function, you can use getAPIInfor()
#	getAPIInfor()
'''
   	"UnicodeEncodeError: 'ascii', u'GET /tag/\u5c0f\u8bf4 HTTP/1.1\r\nAccept-Encoding: 
	identity\r\nHost: book.douban.com\r\nConnection: close\r\nUser-Agent: Python-urllib/2.7\r\n\r\n', 9, 
	11, 'ordinal not in range(128)'"
	You may encounter this problem at the end. It says 'Connection: close', I think maybe douban.com has
	some strategies to revolt crawling.
'''
 
	